#include "fivewin.ch"


function main()

   local oWnd
   
   local hBmp := ReadBitmap( 0, "007.bmp" )
   local hCut := CutImage( 40, 40, 80, 80, hBmp )
   local hDib := DibFromBitmap( hCut )
   
   DibWrite( "test.bmp", hDib )
   
   DeleteObject( hDib )
   DeleteObject( hCut )
   DeleteObject( hBmp )
   

return nil


#pragma BEGINDUMP

#include <hbapi.h>
#include <windows.h>


HB_FUNC( CUTIMAGE )
{
   HDC hdc1, hdcSrc, hdcDest;
   HBITMAP hbmpSrc  = ( HBITMAP ) hb_parnl( 5 );
   HBITMAP hbmpDest, hold1, hold2;
   RECT rct;
   BITMAP bm;
   
   rct.top  = hb_parnl( 1 );
   rct.left = hb_parnl( 2 );
   rct.bottom = hb_parnl( 3 );
   rct.right  = hb_parnl( 4 );
   
   GetObject( ( HGDIOBJ ) hbmpSrc, sizeof( BITMAP ), ( LPSTR ) &bm );

   hdc1 = GetDC( GetDesktopWindow() );
   hdcSrc = CreateCompatibleDC( hdc1 );
   hdcDest = CreateCompatibleDC( hdc1 );

   hbmpDest = CreateCompatibleBitmap( hdc1, rct.right - rct.left, rct.bottom - rct.top );

   ReleaseDC( GetDesktopWindow(), hdc1 );
      
   hold1 = SelectObject( hdcSrc, hbmpSrc );
   hold2 = SelectObject( hdcDest, hbmpDest );
      
   BitBlt( hdcDest, 0, 0, rct.right, rct.bottom, hdcSrc, rct.left, rct.top, SRCCOPY );
   
   SelectObject( hdcSrc, hold1 );
   SelectObject( hdcDest, hold2 );
   
   DeleteDC( hdcSrc );
   DeleteDC( hdcDest );
   
   hb_retnl( ( LONG ) hbmpDest );
   
}


#pragma ENDDUMP